#include "main.h"

Buffer buffer(1920, 1080);

int main(int argc, char** argv){

  Timer timer;

  buffer.clear();
  buffer.setContrast(2);
  buffer.setSamples(8);
  buffer.setItterations(255);
  buffer.setFractal(ALL);

  buffer.setStart(0, 0, 1, -10);
  buffer.setEnd(0, 0, 0.8, 15);

  std::cout << std::endl << buffer.stats() << std::endl << std::endl;

  int frames = 200;
  for(int f=0; f<=frames; f++){

    buffer.clear();
    buffer.cursorUpdate( (float)f/(float)frames );
    for(int y=0; y<buffer.height; y++){
      for(int x=0; x<buffer.width; x++){
        for(int s=0; s<buffer.samples; s++){
          buffer.render(x, y);
        }
      }
    std::cout << "     " << timer.getTime() << "    Frame: " << f << "    " << 100*y/buffer.height << "%    maxValue: " << buffer.getMax() << "           \r" << std::flush;
    }
    std::ostringstream filename;
    filename << "output/frames/image_" << std::setfill('0') << std::setw(5) << f << ".ppm";
    buffer.save( filename.str() );
  }

  std::cout << std::endl << std::endl << "Finished!" << std::endl << std::endl;
  return 0;
}
